"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseJoin = void 0;
const join_node_js_1 = require("../operation-node/join-node.js");
const table_parser_js_1 = require("./table-parser.js");
const filter_parser_js_1 = require("./filter-parser.js");
function parseJoin(ctx, joinType, args) {
    if (args.length === 3) {
        return parseSingleOnJoin(ctx, joinType, args[0], args[1], args[2]);
    }
    else if (args.length === 2) {
        return parseCallbackJoin(ctx, joinType, args[0], args[1]);
    }
    else {
        throw new Error('not implemented');
    }
}
exports.parseJoin = parseJoin;
function parseCallbackJoin(ctx, joinType, from, callback) {
    const joinBuilder = callback(ctx.createJoinBuilder(joinType, from));
    return joinBuilder.toOperationNode();
}
function parseSingleOnJoin(ctx, joinType, from, lhsColumn, rhsColumn) {
    return join_node_js_1.JoinNode.createWithOn(joinType, (0, table_parser_js_1.parseTableExpression)(ctx, from), (0, filter_parser_js_1.parseReferenceFilter)(ctx, lhsColumn, '=', rhsColumn));
}
