import { CheckConstraintNode } from './check-constraint-node.js';
import { ColumnNode } from './column-node.js';
import { DataTypeNode } from './data-type-node.js';
import { DefaultValueNode } from './default-value-node.js';
import { GeneratedNode } from './generated-node.js';
import { OperationNode } from './operation-node.js';
import { RawNode } from './raw-node.js';
import { ReferencesNode } from './references-node.js';
export declare type ColumnDefinitionNodeProps = Omit<Partial<ColumnDefinitionNode>, 'kind' | 'dataType'>;
export declare type ColumnDataTypeNode = DataTypeNode | RawNode;
export interface ColumnDefinitionNode extends OperationNode {
    readonly kind: 'ColumnDefinitionNode';
    readonly column: ColumnNode;
    readonly dataType: ColumnDataTypeNode;
    readonly references?: ReferencesNode;
    readonly primaryKey?: boolean;
    readonly autoIncrement?: boolean;
    readonly unique?: boolean;
    readonly notNull?: boolean;
    readonly defaultTo?: DefaultValueNode;
    readonly check?: CheckConstraintNode;
    readonly generated?: GeneratedNode;
    readonly unsigned?: boolean;
}
/**
 * @internal
 */
export declare const ColumnDefinitionNode: Readonly<{
    is(node: OperationNode): node is ColumnDefinitionNode;
    create(column: string, dataType: ColumnDataTypeNode): ColumnDefinitionNode;
    cloneWith(node: ColumnDefinitionNode, props: ColumnDefinitionNodeProps): ColumnDefinitionNode;
}>;
